Attean::API::Serializer(3pm)

NAME
Attean::API::Serializer - Serializer role

VERSION
This document describes Attean::API::Serializer version 0.030

DESCRIPTION
The Attean::API::Serializer role defines a common API for all serializers of typed objects to data (either a byte string or printed to a filehandle).

REQUIRED METHODS
The following methods are required by the Attean::API::Serializer role:

"canonical_media_type"
    Returns the canonical media type string for the format of this serializer.

"media_types"
    Returns an ARRAY reference of media type strings that also identify the format produced by this serializer.

"handled_type"
    Returns a Type::Tiny object representing the type of items that are consumed during serialization.

"serialize_iter_to_io( $fh, $iterator )"
    Serializes the elements from the Attean::API::Iterator $iterator to the IO::Handle object $fh.

"serialize_iter_to_bytes( $fh )"
    Serializes the elements from the Attean::API::Iterator $iterator and returns the serialization as a UTF-8 encoded byte string.

METHODS
This role provides default implementations of the following methods:

"serialize_list_to_io( $fh, @elements )"
    Serializes the objects in @elements to the IO::Handle object $fh.

"serialize_list_to_bytes( @elements )"
    Serializes the objects in @elements and returns the serialization as a UTF-8 encoded byte string.

BUGS
Please report any bugs or feature requests to through the GitHub web interface at <https://github.com/kasei/attean/issues>.

SEE ALSO

AUTHOR
Gregory Todd Williams "<gwilliams@cpan.org>"

COPYRIGHT
Copyright (c) 2014--2020 Gregory Todd Williams. This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.